from functools import wraps
import services
import sims4.resources
from sims4.tuning.instance_manager import InstanceManager
from sims4.resources import Types

def inject(target_function, new_function):
    @wraps(target_function)
    def _inject(*args, **kwargs):
        return new_function(target_function, *args, **kwargs)
    return _inject

def inject_to(target_object, target_function_name):
    def _inject_to(new_function):
        target_function = getattr(target_object, target_function_name)
        setattr(target_object, target_function_name, inject(target_function, new_function))
        return new_function
    return _inject_to

SeSeSimmi_BusinessMod_ObjectIds_1 = (14961,180047,207057,25188,)
SeSeSimmi_BusinessMod_InteractionIds_1 = (4036910519,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BusinessMod_AddSuperAffordances_1(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_BusinessMod_InteractionIds_1:
            key = sims4.resources.get_resource_key(sa_id, Types.INTERACTION)
            sa_tuning = affordance_manager.get(key)
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        for obj_id in SeSeSimmi_BusinessMod_ObjectIds_1:
            key = sims4.resources.get_resource_key(obj_id, Types.OBJECT)
            obj_tuning = self._tuned_classes.get(key)
            if not obj_tuning is None:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_BusinessMod_ObjectIds_2 = (14845,34678,34679,34680,34682,34684,36369,36370,40340,77507,202931,202932,211714,238959,238960,239031,)
SeSeSimmi_BusinessMod_InteractionIds_2 = (2996138959,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BusinessMod_AddSuperAffordances_2(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_BusinessMod_InteractionIds_2:
            key = sims4.resources.get_resource_key(sa_id, Types.INTERACTION)
            sa_tuning = affordance_manager.get(key)
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        for obj_id in SeSeSimmi_BusinessMod_ObjectIds_2:
            key = sims4.resources.get_resource_key(obj_id, Types.OBJECT)
            obj_tuning = self._tuned_classes.get(key)
            if not obj_tuning is None:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_BusinessMod_ObjectIds_3 = (149493,)
SeSeSimmi_BusinessMod_InteractionIds_3 = (3574539778,3322555151,3085124261,2970489861,3869150712,2537069926,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BusinessMod_AddSuperAffordances_3(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_BusinessMod_InteractionIds_3:
            key = sims4.resources.get_resource_key(sa_id, Types.INTERACTION)
            sa_tuning = affordance_manager.get(key)
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        for obj_id in SeSeSimmi_BusinessMod_ObjectIds_3:
            key = sims4.resources.get_resource_key(obj_id, Types.OBJECT)
            obj_tuning = self._tuned_classes.get(key)
            if not obj_tuning is None:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_BusinessMod_ObjectIds_4 = (14845,34678,34679,34680,34682,34684,36369,36370,40340,77507,202931,202932,211714,238959,238960,239031,291090,149493,149493,)
SeSeSimmi_BusinessMod_InteractionIds_4 = (2770433003,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BusinessMod_AddSuperAffordances_4(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_BusinessMod_InteractionIds_4:
            key = sims4.resources.get_resource_key(sa_id, Types.INTERACTION)
            sa_tuning = affordance_manager.get(key)
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        for obj_id in SeSeSimmi_BusinessMod_ObjectIds_4:
            key = sims4.resources.get_resource_key(obj_id, Types.OBJECT)
            obj_tuning = self._tuned_classes.get(key)
            if not obj_tuning is None:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_BusinessMod_ObjectIds_5 = (14845,34678,34679,34680,34682,34684,36369,36370,40340,77507,202931,202932,211714,238959,238960,239031,291090,)
SeSeSimmi_BusinessMod_InteractionIds_5 = (2490398182,2613829205,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BusinessMod_AddSuperAffordances_5(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_BusinessMod_InteractionIds_5:
            key = sims4.resources.get_resource_key(sa_id, Types.INTERACTION)
            sa_tuning = affordance_manager.get(key)
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        for obj_id in SeSeSimmi_BusinessMod_ObjectIds_5:
            key = sims4.resources.get_resource_key(obj_id, Types.OBJECT)
            obj_tuning = self._tuned_classes.get(key)
            if not obj_tuning is None:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_BusinessMod_ObjectIds_6 = (14845,34678,34679,34680,34682,34684,36369,36370,40340,77507,202931,202932,)
SeSeSimmi_BusinessMod_InteractionIds_6 = (3722132153,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BusinessMod_AddSuperAffordances_6(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_BusinessMod_InteractionIds_6:
            key = sims4.resources.get_resource_key(sa_id, Types.INTERACTION)
            sa_tuning = affordance_manager.get(key)
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        for obj_id in SeSeSimmi_BusinessMod_ObjectIds_6:
            key = sims4.resources.get_resource_key(obj_id, Types.OBJECT)
            obj_tuning = self._tuned_classes.get(key)
            if not obj_tuning is None:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_BusinessMod_TargetInteractionIds_1 = (4036910519,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BusinessMod_AddSuperAffordances_BasedOnInteraction_1(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_BusinessMod_TargetInteractionIds_1:
            sa_tuning = affordance_manager.get(sims4.resources.get_resource_key(sa_id, Types.INTERACTION))
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        object_manager = services.get_instance_manager(Types.OBJECT)
        for obj_tuning in object_manager.types.values():
            if obj_tuning is None:
                continue
            if affordance_manager.get(sims4.resources.get_resource_key(33623, Types.INTERACTION)) in obj_tuning._super_affordances:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_BusinessMod_TargetInteractionIds_2 = (4036910519,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BusinessMod_AddSuperAffordances_BasedOnInteraction_2(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_BusinessMod_TargetInteractionIds_2:
            sa_tuning = affordance_manager.get(sims4.resources.get_resource_key(sa_id, Types.INTERACTION))
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        object_manager = services.get_instance_manager(Types.OBJECT)
        for obj_tuning in object_manager.types.values():
            if obj_tuning is None:
                continue
            if affordance_manager.get(sims4.resources.get_resource_key(24396, Types.INTERACTION)) in obj_tuning._super_affordances:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_BusinessMod_TargetInteractionIds_3 = (3574539778,3869150712,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BusinessMod_AddSuperAffordances_BasedOnInteraction_3(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_BusinessMod_TargetInteractionIds_3:
            sa_tuning = affordance_manager.get(sims4.resources.get_resource_key(sa_id, Types.INTERACTION))
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        object_manager = services.get_instance_manager(Types.OBJECT)
        for obj_tuning in object_manager.types.values():
            if obj_tuning is None:
                continue
            if affordance_manager.get(sims4.resources.get_resource_key(13784, Types.INTERACTION)) in obj_tuning._super_affordances:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_BusinessMod_TargetInteractionIds_4 = (2490398182,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BusinessMod_AddSuperAffordances_BasedOnInteraction_4(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_BusinessMod_TargetInteractionIds_4:
            sa_tuning = affordance_manager.get(sims4.resources.get_resource_key(sa_id, Types.INTERACTION))
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        object_manager = services.get_instance_manager(Types.OBJECT)
        for obj_tuning in object_manager.types.values():
            if obj_tuning is None:
                continue
            if affordance_manager.get(sims4.resources.get_resource_key(31652, Types.INTERACTION)) in obj_tuning._super_affordances:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_BusinessMod_TargetInteractionIds_5 = (2490398182,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BusinessMod_AddSuperAffordances_BasedOnInteraction_5(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_BusinessMod_TargetInteractionIds_5:
            sa_tuning = affordance_manager.get(sims4.resources.get_resource_key(sa_id, Types.INTERACTION))
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        object_manager = services.get_instance_manager(Types.OBJECT)
        for obj_tuning in object_manager.types.values():
            if obj_tuning is None:
                continue
            if affordance_manager.get(sims4.resources.get_resource_key(9561, Types.INTERACTION)) in obj_tuning._super_affordances:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_BusinessMod_ObjectIds_Phone = (14965,)
SeSeSimmi_BusinessMod_InteractionIds_Phone = (2996138959,3574539778,2770433003,3322555151,3085124261,3847761780,2970489861,3611580369,3869150712,2537069926,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BusinessMod_AddSuperAffordances_Phone(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_BusinessMod_InteractionIds_Phone:
            key = sims4.resources.get_resource_key(sa_id, Types.INTERACTION)
            sa_tuning = affordance_manager.get(key)
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        for obj_id in SeSeSimmi_BusinessMod_ObjectIds_Phone:
            key = sims4.resources.get_resource_key(obj_id, Types.OBJECT)
            obj_tuning = self._tuned_classes.get(key)
            if not obj_tuning is None:
                obj_tuning._phone_affordances = obj_tuning._phone_affordances + sa_tuple

SeSeSimmi_BusinessMod_163702_SnippetId = 163702
SeSeSimmi_BusinessMod_163702_MixerId = (3868124470,2675939502,3434501581,2718608884,3150027394,2536822798,2741498544,4193476091,2246997054,3324764748,3381816955,3086999477,2837612792,2248637719,2953520386,3713303138,2830017452,2385337706,3827435446,3047309486,4243038047,3608557839,2313997027,3109724185,2927494163,2279391682,2634211018,3378076934,4283504237,2310441616,2252001302,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BusinessMod_AddMixer_163702(original, self):
    original(self)
    if self.TYPE == Types.SNIPPET:
        key = sims4.resources.get_resource_key(SeSeSimmi_BusinessMod_163702_SnippetId, Types.SNIPPET)
        snippet_tuning = self._tuned_classes.get(key)
        if snippet_tuning is None:
            return
        for m_id in SeSeSimmi_BusinessMod_163702_MixerId:
            affordance_manager = services.affordance_manager()
            key = sims4.resources.get_resource_key(m_id, Types.INTERACTION)
            mixer_tuning = affordance_manager.get(key)
            if mixer_tuning is None:
                continue
            if mixer_tuning in snippet_tuning.value:
                continue
            snippet_tuning.value = snippet_tuning.value + (mixer_tuning, )

